/*********************************************
 * vim:sw=8:ts=8:si:et
 * To use the above modeline in vim you must have "set modeline" in your .vimrc
 * Author: Guido Socher
 * Copyright: GPL V2
 * See http://www.gnu.org/licenses/gpl.html
 *
 * Ethernet remote device and sensor
 * UDP and HTTP interface 
        url looks like this http://baseurl/password/command
        or http://baseurl/password/
 *
 * Title: Microchip ENC28J60 Ethernet Interface Driver
 * Chip type           : ATMEGA88 with ENC28J60
 * Note: there is a version number in the text. Search for tuxgraphics
 *********************************************/


/*********************************************
 * modified: 2007-08-08
 * Author  : awake
 * Copyright: GPL V2
 * http://www.icdev.com.cn/?2213/
 * Host chip: ADUC7026
**********************************************/
//#include <includes.h>
#include <string.h>
#include <stdio.h>
#include "enc28j60.h"
#include <stm32f10x.h>
#include "ip_arp_udp_tcp.h"
#include "net.h"
#include "simple_server.h"
#define PSTR(s) s

//extern void delay_ms(unsigned char ms);

// please modify the following two lines. mac and ip have to be unique
// in your local area network. You can not have the same numbers in
// two devices:
static unsigned char mymac[6] = {0x54,0x55,0x58,0x10,0x00,0x24};
static unsigned char myip[4] = {192,168,0,107};
// base url (you can put a DNS name instead of an IP addr. if you have
// a DNS server (baseurl must end in "/"):
static char baseurl[]="http://my.kiloom.com/";
static unsigned int mywwwport =80; // listen port for tcp/www (max range 1-254)
// or on a different port:
//static char baseurl[]="http://10.0.0.24:88/";
//static unsigned int mywwwport =88; // listen port for tcp/www (max range 1-254)
//
static unsigned int myudpport =1200; // listen port for udp
// how did I get the mac addr? Translate the first 3 numbers into ascii is: TUX

#define BUFFER_SIZE 1500//400
static unsigned char buf[BUFFER_SIZE+1];
char temperature [20];//Dallas Temperature

// the password string (only the first 5 char checked), (only a-z,0-9,_ characters):
static char password[]="1234"; // must not be longer than 9 char
unsigned char field=2;

/*
const char MyWebSide[] = {
		"<body bgcolor=#eeeeee>\r\n"
		"<form method=get>\r\n"
		"<input name=led type=checkbox value=1>On/Off\r\n"
		"<input name=submit type=Submit value=Ok>\r\n"
		"</form>\r\n"
		"</body>\r\n"
		"</html>\r\n"

};
*/
// 
unsigned char verify_password(char *str)
	{
	// the first characters of the received string are
	// a simple password/cookie:
	if (strncmp(password,str,5)==0)
		{
	    return(1);
		}
	return(0);
	}

// takes a string of the form password/commandNumber and analyse it
// return values: -1 invalid password, otherwise command number
//                -2 no command given but password valid
unsigned char analyse_get_url(char *str)
	{
	unsigned char i=0;
	if (verify_password(str)==0)
		{
		return(-1);
		}
	// find first "/"
	// passw not longer than 9 char:
	while(*str && i<10 && *str >',' && *str<'{')
		{
        if (*str=='/')
			{
            str++;
            break;
        	}
        i++;
        str++;
		}
	if (*str < 0x3a && *str > 0x2f)
		{
        // is a ASCII number, return it
        return(*str-0x30);
		}
	return(-2);
	}

// prepare the webpage by writing the data to the tcp send buffer
unsigned int print_webpage(unsigned char *buf,unsigned char on_off)
	{
    unsigned int plen=0;
    //plen=fill_tcp_data_p(buf,0,PSTR("HTTP/1.0 200 OK\r\nContent-Type: text/html\r\nPragma: no-cache\r\n"));
    plen=fill_tcp_data_p(buf,plen,PSTR("<head><meta http-equiv=Content-Type content=text/html; charset=windows-1251 /></head>"));
    // the url looks like this http://baseurl/password/command
    //plen=fill_tcp_data(buf,plen,baseurl);
    //plen=fill_tcp_data(buf,plen,password);
    //plen=fill_tcp_data_p(buf,plen,PSTR("</center><br><hr>STM32F103RBT + ENC28J60 <br> Ethernet mini WEB-server\n"));
    plen=fill_tcp_data_p(buf,plen,PSTR("<hr><center><h3>   STM32! ;)</h3></center><hr><br>\n"));
    //plen=fill_tcp_data_p(buf,plen,PSTR(MyWebSide));

    //Check LED state
    plen=fill_tcp_data_p(buf,plen,PSTR("<form method=get>"));
    plen=fill_tcp_data_p(buf,plen,PSTR("<select name=led size=1>"));
    if(on_off>-1)
    {
    	if(on_off)
    	{
    		plen=fill_tcp_data_p(buf,plen,PSTR("<option value=1 selected>ON</option>"));
    		plen=fill_tcp_data_p(buf,plen,PSTR("<option value=0 >OFF</option>"));
    	}
    	else
    	{
    		plen=fill_tcp_data_p(buf,plen,PSTR("<option value=1>ON</option>"));
    		plen=fill_tcp_data_p(buf,plen,PSTR("<option value=0 selected>OFF</option>"));
    	}
    }
    else
    {
   		plen=fill_tcp_data_p(buf,plen,PSTR("<option value=1>ON</option>"));
    	plen=fill_tcp_data_p(buf,plen,PSTR("<option value=0 selected>OFF</option>"));
    }
    plen=fill_tcp_data_p(buf,plen,PSTR("</select>"));
    plen=fill_tcp_data_p(buf,plen,PSTR("Password:"));
    plen=fill_tcp_data_p(buf,plen,PSTR("<input type=password name=passw size=10 maxlength=4>"));
//    plen=fill_tcp_data_p(buf,plen,PSTR("<input type=text name=field size="));
//	sprintf (temperature, "%d maxlength=2>", field);
//	plen=fill_tcp_data_p(buf,plen,PSTR(temperature));
    plen=fill_tcp_data_p(buf,plen,PSTR("<input name=submit type=Submit value=Ok><br>"));
    plen=fill_tcp_data_p(buf,plen,PSTR("<a href=/><input name=re type=button value=Refresh></a>"));
    plen=fill_tcp_data_p(buf,plen,PSTR("</form>"));
//    plen=fill_tcp_data_p(buf,plen,PSTR(temperature));
    sprintf (temperature, "<br>Led PORT is: %d", on_off);
    plen=fill_tcp_data_p(buf,plen,PSTR(temperature));
    plen=fill_tcp_data_p(buf,plen,PSTR("</html>"));

    return(plen);
	}

int simple_server(void)
	{      
    unsigned int plen;
    unsigned int dat_p;
    unsigned char i=0;
    unsigned char cmd_pos=0;
    unsigned char cmd=-1;
    unsigned char payloadlen=0;
    char str[30];
	char vrem_buf[50];
    char cmdval;

        
//	Del_1ms(100);
	/*initialize enc28j60*/
	enc28j60Init(mymac);
	init_ip_arp_udp_tcp(mymac,myip,mywwwport);
    //ָʾ״̬:0x476 is PHLCON LEDA()=links status, LEDB()=receive/transmit
    enc28j60PhyWrite(PHLCON,0x476);
	enc28j60clkout(2); // change clkout from 6.25MHz to 12.5MHz
//	Del_1ms(20);

	//init the ethernet/ip layer:
    while(1)
    	{
//		OSTimeDlyHMSM(0, 0, 0, 50);
        // get the next new packet:
        plen = enc28j60PacketReceive(BUFFER_SIZE, buf);
        //USART_DMASendData(USART1,buf,plen);

        /*plen will ne unequal to zero if there is a valid packet (without crc error) */
        if(plen==0)
        	{
        		continue;
        	}
        // arp is broadcast if unknown but a host may also
        // verify the mac address by sending it to 
        // a unicast address.
        if(eth_type_is_arp_and_my_ip(buf,plen))
        	{
        	//GPIO_SetBits(GPIOA,GPIO_Pin_3);//Led ON
			make_arp_answer_from_request(buf);
			//USART_DMASendText(USART1,"make_arp_answer_from_request\n");
            continue;
        	}

        // check if ip packets are for us:
        if(eth_type_is_ip_and_my_ip(buf,plen)==0)
        	{
            continue;
        	}


        if(buf[IP_PROTO_P]==IP_PROTO_ICMP_V && buf[ICMP_TYPE_P]==ICMP_TYPE_ECHOREQUEST_V)
        	{
            // a ping packet, let's send pong	
			make_echo_reply_from_request(buf, plen);
			//USART_DMASendText(USART1,"make_echo_reply_from_request\n");
			continue;
        	}
        // tcp port www start, compare only the lower byte
		if (buf[IP_PROTO_P]==IP_PROTO_TCP_V && buf[TCP_DST_PORT_H_P]==0 && buf[TCP_DST_PORT_L_P]==mywwwport)
			{
            if (buf[TCP_FLAGS_P] & TCP_FLAGS_SYN_V)
				{
                make_tcp_synack_from_syn(buf);
                // make_tcp_synack_from_syn does already send the syn,ack
                continue;
            	}
	        if (buf[TCP_FLAGS_P] & TCP_FLAGS_ACK_V)
				{
	            init_len_info(buf); // init some data structures
	            // we can possibly have no data, just ack:
	            dat_p=get_tcp_data_pointer();
	            if (dat_p==0)
					{
	                if (buf[TCP_FLAGS_P] & TCP_FLAGS_FIN_V)
						{
	                    // finack, answer with ack
	                    make_tcp_ack_from_any(buf);
	                	}
	                // just an ack with no data, wait for next packet
	                continue;
	                }
				if (strncmp("GET ",(char *)&(buf[dat_p]),4)!=0)
					{
			        // head, post and other methods:
			        //
			        // for possible status codes see:
			        // http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html
			        plen=fill_tcp_data_p(buf,0,PSTR("HTTP/1.0 200 OK\r\n"));
			        goto SENDTCP;
					}
			//	if (strncmp("/ ",(char *)&(buf[dat_p+4]),2)==0)
			//		{
			//        plen=fill_tcp_data_p(buf,0,PSTR("HTTP/1.0 200 OK\r\nContent-Type: text/html\r\n\r\n"));
			//        plen=fill_tcp_data_p(buf,plen,PSTR("<p>Usage: "));
			//        plen=fill_tcp_data(buf,plen,baseurl);
			//        plen=fill_tcp_data_p(buf,plen,PSTR("password</p>"));
			//        goto SENDTCP;
			//		}

				strncpy(vrem_buf,(char *)&(buf[dat_p+4]),50);

				if(strstr(vrem_buf,password))
				{
					if(strstr(vrem_buf,"led=0"))
					{
						i=0;//State port
						GPIO_ResetBits(GPIOA,GPIO_Pin_3);//Port OFF
					}

					if(strstr(vrem_buf,"led=1"))
					{
						i=1;//State port
						GPIO_SetBits(GPIOA,GPIO_Pin_3);//Port ON
					}
				}
				else i=-1;

				// if (cmd==-2) or any other value
				// just display the status:
				plen=print_webpage(buf,(i));

				SENDTCP:
				make_tcp_ack_from_any(buf); // send ack for http get
				make_tcp_ack_with_data(buf,plen); // send data
				continue;
				}
			}
	// tcp port www end
	//
	// udp start, we listen on udp port 1200=0x4B0
		if (buf[IP_PROTO_P]==IP_PROTO_UDP_V && buf[UDP_DST_PORT_H_P]==0x04 && buf[UDP_DST_PORT_L_P]==0xb0)
			{
				payloadlen=buf[UDP_LEN_L_P]-UDP_HEADER_LEN;
			// you must sent a string starting with v
			// e.g udpcom version 10.0.0.24
		if (buf[UDP_DATA_P])
				{
				// find the first comma which indicates 
				// the start of a command:
				//cmd_pos=0;
				//while(cmd_pos<payloadlen)
				//	{
				//	cmd_pos++;
				//	if (buf[UDP_DATA_P+cmd_pos]==',')
				//		{
				//	    cmd_pos++; // put on start of cmd
				//	    break;
				//		}
				//	}

				if(buf[UDP_DATA_P+0]=='1')
				{
					strcpy(str,"Hello Alexey!");
				}
				else
				{
					strcpy(str,"Thank You!");
				}
				// a command is one char and a value. At
				// least 3 characters long. It has an '=' on
				// position 2:
/*
				if (cmd_pos<2 || cmd_pos>payloadlen-3 || buf[UDP_DATA_P+cmd_pos+1]!='=')
					{
					strcpy(str,"e=no_cmd");
					goto ANSWER;
					}
				// supported commands are
				// t=1 t=0 t=?
				if (buf[UDP_DATA_P+cmd_pos]=='t')
					{
					cmdval=buf[UDP_DATA_P+cmd_pos+2];
					if(cmdval=='1')
							{
						    //PORTD|= (1<<PD7);// transistor on
							//IOCLR |= (1<<26);
                            //LED1ON();
						    strcpy(str,"t=1");
						    goto ANSWER;
							}
						else if(cmdval=='0')
							{
						    //PORTD &= ~(1<<PD7);// transistor off
							//IOSET |= (1<<26);
                            //LED1OFF();
						    strcpy(str,"t=0");
						    goto ANSWER;
							}
						else if(cmdval=='?')
							{

						    //if (IOPIN & (1<<26))
							//	{
					        //    strcpy(str,"t=1");
					        //    goto ANSWER;
						    //	}

						    strcpy(str,"t=0");
						    goto ANSWER;
							}
					}
				strcpy(str,"e=no_such_cmd");
				goto ANSWER;*/
				}

			ANSWER:
			//strcpy(str,"Hello Alexey!");
			make_udp_reply_from_request(buf,str,strlen(str),myudpport);
			
			}

	}

return (0);
}
